/*---------------------------------------------------------------------------*/
/*                                                                           */
/* Joe Boudreau, Mark Fishler, Andreas Pfeiffer                              */
/*									     */
/*                                                                           */
/*---------------------------------------------------------------------------*/
#ifndef _GSLMetaProxy_h_
#define _GSLMetaProxy_h_

/*---------------------------------------------------------------------------*/
/*                                                                           */
/*    This is the error code for all MP functions, it means unimplemented:   */ 
/*                                                                           */
/*---------------------------------------------------------------------------*/

#define GSLMP_NOT_IMPLEMENTED 100

/*---------------------------------------------------------------------------*/
/*                                                                           */
/*    This result structure, as defined in the GSL:                          */ 
/*                                                                           */
/*---------------------------------------------------------------------------*/


typedef struct
{
  double val;
  double err;
} gsl_sf_result;


#ifdef __cplusplus
extern "C" {
#endif

    /* The Integral-order Bessel Functions:                                  */
    int gsl_sf_bessel_Jn_impl(int n, double x, gsl_sf_result * result);
    int gsl_sf_bessel_Yn_impl(int n, double x, gsl_sf_result * result);

    /* The Fractional-order Bessel Functions:                                */
    int gsl_sf_bessel_Jnu_impl (double nu, double x, gsl_sf_result *result);
    int gsl_sf_bessel_Ynu_impl (double nu, double x, gsl_sf_result *result);

    /* The Spherical Bessel Functions:                                       */
    int gsl_sf_bessel_jl_impl(const int l, const double x, gsl_sf_result * result);
    int gsl_sf_bessel_yl_impl(const int l, const double x, gsl_sf_result * result);

#ifdef __cplusplus
}
#endif

#endif
