// $Id: ReadNextHepMC.cc,v 1.1 2002/05/01 22:05:31 garren Exp $
// ----------------------------------------------------------------------
//
// ReadNextHepMC.cc
// Author: Lynn Garren
//
// read from an ascii file
// ----------------------------------------------------------------------

#include "CLHEP/config/CLHEP.h"
#include "CLHEP/config/iostream.h"
#include "CLHEP/config/fstream.h"
#include <string>

#include "CLHEP/HepMC/ReadHepMC.h"
#include "CLHEP/HepMC/GenEvent.h"

namespace HepMC  {

GenEvent * findNextGenEvent( std::istream & is )
{
    // check the state of the input stream
    if ( !is ) return NULL;
    //
    // find an event block
    std::string type("GenEvent");
    bool ok = findBlockType( is, type );
    // read the event
    if( ok ) {
	GenEvent * evt = readGenEvent( is );
        return evt;
    }
    // no event has been found
    return NULL;
}

}	// HepMC
