// $Id: write.cc,v 1.3 2001/11/19 23:22:37 garren Exp $
// ----------------------------------------------------------------------
//
// write.cc
//
// ----------------------------------------------------------------------

#include "CLHEP/config/CLHEP.h"
#include "CLHEP/config/iomanip.h"

#include "CLHEP/config/sstream.h"
#include "CLHEP/HepPDT/CommonParticleData.hh"

namespace HepPDT {

void CommonParticleData::write( std::ostream & ostr ) const
{
    Measurement mass = itsResonance->mass();
    Measurement width = itsResonance->totalWidth();
    Measurement ctau = lifetime();
    int il = itsParticleName.length();
    ostr << itsParticleName ;
    // pad the name
    int pad;
    for( pad = 0; pad < 20 - il; ++pad ) {
        ostr << " " ;
    }
    ostr.width(12);
    ostr <<  itsID.pid();
    ostr.width(8);
    ostr.precision(4);
    ostr << itsCharge;
    ostr.width(5);
    ostr.precision(2);
    ostr << " " << itsColorCharge;
    ostr.width(5);
    ostr << itsSpin.totalSpin() ;
    ostr.width(5);
    ostr << itsSpin.spin() ;
    ostr.width(5);
    ostr << itsSpin.orbAngMom() ;
    ostr.width(12);
    ostr.precision(4);
    ostr.setf(std::ios::scientific, std::ios::floatfield);
    ostr << mass.value() << "+/-" << mass.sigma() ;
    ostr.width(12);
    ostr.precision(4);
    ostr << width.value() << "+/-" << width.sigma() ;
    ostr.width(12);
    ostr.precision(4);
    ostr << ctau.value() << "+/-" << ctau.sigma();
    // return to default settings
    ostr.precision(6);
    ostr.setf(std::ios::fmtflags(0), std::ios::floatfield);
    // end the line
    ostr << std::endl;
}

}	// HepPDT
