// $Id: writeTranslations.cc,v 1.3 2001/11/19 23:22:38 garren Exp $
// ----------------------------------------------------------------------
//
// writeTranslations.cc
// Author: Lynn Garren
//
// ----------------------------------------------------------------------

#include "CLHEP/config/CLHEP.h"
#include "CLHEP/config/iomanip.h"

#include "CLHEP/config/sstream.h"
#include "CLHEP/HepPDT/PDGtoQQTable.hh"

namespace HepPDT {

void PDGtoQQTable::writeTranslations( std::ostream & os ) const
{
  int i, ipdt, iqq;
  for( i=0; i<QQTOPDTARRAYSIZE; ++i ) {
      ipdt = itsQQtoPDTarray[i];
      const_iterator it = itsPDTtoQQmap.find( ipdt );
      if( it != itsPDTtoQQmap.end() ) {
	  iqq = it->second;
      } else {
          iqq = 0;
      }
      os << " index " ;
      os.width(5);
      os << i << "  PDT number " ;
      os.width(12);
      os << ipdt << "  QQ number " ;
      os.width(5);
      os << iqq << std::endl;
  }
}

}  // namespace HepPDT
