// -*- C++ -*-
// $Id: ranRestoreTest.cc,v 1.1 2001/04/04 15:45:40 mf Exp $
// ----------------------------------------------------------------------
#include "CLHEP/Random/Randomize.h"
#include "CLHEP/config/iostream.h"

double remembered_r2;
double remembered_r1005;
double remembered_r1006;
double remembered_r1007;

// ------------------- The following should all FAIL ------------

void saveStepX() {
  double r = RandGauss::shoot();
  HepStd::cout << "r(1) = " << r << HepStd::endl;
  HepRandom::saveEngineStatus();
  r = RandGauss::shoot();
  HepStd::cout << "r(2) = " << r << HepStd::endl;
  remembered_r2 = r;
  r = RandGauss::shoot();
  HepStd::cout << "r(3) = " << r << HepStd::endl;
  for (int i=0; i < 1001; i++) {
    r = RandGauss::shoot();
  }    
  r = RandGauss::shoot();
  remembered_r1005 = r;
  HepStd::cout << "r1005= " << r << HepStd::endl;
  r = RandGauss::shoot();
  return;
}

void restoreStepX() {
  HepRandom::restoreEngineStatus();
  double r = RandGauss::shoot();
  HepStd::cout << "restored r(2) = " << r << HepStd::endl;
  if ( r != remembered_r2 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  r = RandGauss::shoot();
  HepStd::cout << "restored r(3) = " << r << HepStd::endl;
  for (int i=0; i < 1001; i++) {
    r = RandGauss::shoot();
  }    
  r = RandGauss::shoot();
  HepStd::cout << "restored r1005= " << r << HepStd::endl;
  if ( r != remembered_r1005 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  return;
}

void BsaveStepX() {
  int r = RandFlat::shootBit();
  HepStd::cout << "r(1) = " << r << HepStd::endl;
  HepRandom::saveEngineStatus();
  r = RandFlat::shootBit();
  HepStd::cout << "r(2) = " << r << HepStd::endl;
  remembered_r2 = r;
  r = RandFlat::shootBit();
  HepStd::cout << "r(3) = " << r << HepStd::endl;
  double d;
  for (int i=0; i < 1001; i++) {
    d = RandFlat::shoot();
    if (d > 1) HepStd::cout << 
    "This line inserted so clever compilers don't warn about not using d\n";
  }    
  r = RandFlat::shootBit();
  remembered_r1005 = r;
  HepStd::cout << "r1005= " << r << HepStd::endl;
  r = RandFlat::shootBit();
  return;
}

void BrestoreStepX() {
  HepRandom::restoreEngineStatus();
  int r = RandFlat::shootBit();
  HepStd::cout << "restored r(2) = " << r << HepStd::endl;
  if ( r != remembered_r2 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  r = RandFlat::shootBit();
  HepStd::cout << "restored r(3) = " << r << HepStd::endl;
  for (int i=0; i < 1001; i++) {
    r = RandFlat::shootBit();
  }    
  r = RandFlat::shootBit();
  HepStd::cout << "restored r1005= " << r << HepStd::endl;
  if ( r != remembered_r1005 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  return;
}

// ------------------- The following should all WORK ------------

void saveStep() {
  double r = RandGauss::shoot();
  HepStd::cout << "r(1) = " << r << HepStd::endl;
  RandGauss::saveEngineStatus();
  r = RandGauss::shoot();
  HepStd::cout << "r(2) = " << r << HepStd::endl;
  remembered_r2 = r;
  r = RandGauss::shoot();
  HepStd::cout << "r(3) = " << r << HepStd::endl;
  for (int i=0; i < 1001; i++) {
    r = RandGauss::shoot();
  }    
  r = RandGauss::shoot();
  remembered_r1005 = r;
  HepStd::cout << "r1005= " << r << HepStd::endl;
  r = RandGauss::shoot();
  return;
}

void restoreStep() {
  RandGauss::restoreEngineStatus();
  double r = RandGauss::shoot();
  HepStd::cout << "restored r(2) = " << r << HepStd::endl;
  if ( r != remembered_r2 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  r = RandGauss::shoot();
  HepStd::cout << "restored r(3) = " << r << HepStd::endl;
  for (int i=0; i < 1001; i++) {
    r = RandGauss::shoot();
  }    
  r = RandGauss::shoot();
  HepStd::cout << "restored r1005= " << r << HepStd::endl;
  if ( r != remembered_r1005 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  return;
}

void BsaveStep() {
  int r = RandFlat::shootBit();
  HepStd::cout << "r(1) = " << r << HepStd::endl;
  RandFlat::saveEngineStatus();
  r = RandFlat::shootBit();
  HepStd::cout << "r(2) = " << r << HepStd::endl;
  remembered_r2 = r;
  r = RandFlat::shootBit();
  HepStd::cout << "r(3) = " << r << HepStd::endl;
  for (int i=0; i < 1001; i++) {
    r = RandFlat::shootBit();
  }    
  r = RandFlat::shootBit();
  remembered_r1005 = r;
  HepStd::cout << "r1005 = " << r << HepStd::endl;
  r = RandFlat::shootBit();
  remembered_r1006 = r;
  HepStd::cout << "r1006 = " << r << HepStd::endl;
  r = RandFlat::shootBit();
  remembered_r1007 = r;
  HepStd::cout << "r1007 = " << r << HepStd::endl;
  r = RandFlat::shootBit();
  return;
}

void BrestoreStep() {
  RandFlat::restoreEngineStatus();
  int r = RandFlat::shootBit();
  HepStd::cout << "restored r(2) = " << r << HepStd::endl;
  if ( r != remembered_r2 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  r = RandFlat::shootBit();
  HepStd::cout << "restored r(3) = " << r << HepStd::endl;
  for (int i=0; i < 1001; i++) {
    r = RandFlat::shootBit();
  }    
  r = RandFlat::shootBit();
  HepStd::cout << "restored r1005= " << r << HepStd::endl;
  if ( r != remembered_r1005 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  r = RandFlat::shootBit();
  HepStd::cout << "restored r1006= " << r << HepStd::endl;
  if ( r != remembered_r1006 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  r = RandFlat::shootBit();
  HepStd::cout << "restored r1007= " << r << HepStd::endl;
  if ( r != remembered_r1007 ) {
    HepStd::cout << "????? THIS DOES NOT MATCH REMEMBERED VALUE!\n";
  }
  return;
}

// --------------------------------------------------


int main() {
  HepStd::cout << "Using old method or HepRandom::saveEngineStatus:\n";
  HepStd::cout << "All these tests should have a chance of failure.\n";

  saveStepX();
  restoreStepX();
  BsaveStepX();
  BrestoreStepX();
  
  HepStd::cout << "Using the class-specifice RandGauss::saveEngineStatus:\n";
  HepStd::cout << "All these tests should work properly.\n";

  saveStep();
  restoreStep();
  BsaveStep();
  BrestoreStep();
  
  return 0;
}	

