// $Id: readStdEvent.cc,v 1.3 2002/05/01 20:31:58 garren Exp $
// ----------------------------------------------------------------------
//
// readStdEvent.cc
// Author: Lynn Garren
//
// read from an ascii file
// process a single event - do not combine events
// ----------------------------------------------------------------------

#include "CLHEP/config/CLHEP.h"
#include "CLHEP/config/iostream.h"
#include "CLHEP/config/fstream.h"
#include <string>

#include "CLHEP/StdHep/ReadStdHep.hh"
#include "CLHEP/HepMC/ReadHepMC.h"
#include "CLHEP/StdHep/StdEvent.hh"

namespace StdHep  {

StdEvent * readStdEvent( std::istream & is )
{
    // check the state of the input stream
    if ( !is ) return NULL;
    //
    // read the event
    std::string evline;
    std::getline( is, evline);
    if( evline.find("S ") == 0 ) {
	StdEvent * evt = Detail::readStdEventInfo( is, evline );
        return evt;
    }
    // no event has been found
    return NULL;
}

}	// StdHep
