// -*- C++ -*-
// ---------------------------------------------------------------------------
//
// This file is a part of the CLHEP - a Class Library for High Energy Physics.
//
// This is the implementation of the output method of the HepRotation class,
// which was introduced when ZOOM PhysicsVectors was merged in.
//

#ifdef GNUPRAGMA
#pragma implementation
#endif

#include "CLHEP/config/iostream.h"
#include "CLHEP/config/iomanip.h"
#include "CLHEP/Vector/Rotation.h"

HepStd::ostream & HepRotation::print( HepStd::ostream & os ) const {
  os << "\n   [ ( " <<
        HepStd::setw(11) << HepStd::setprecision(6) << xx() << "   " <<
        HepStd::setw(11) << HepStd::setprecision(6) << xy() << "   " <<
        HepStd::setw(11) << HepStd::setprecision(6) << xz() << ")\n"
     << "     ( " <<
        HepStd::setw(11) << HepStd::setprecision(6) << yx() << "   " <<
        HepStd::setw(11) << HepStd::setprecision(6) << yy() << "   " <<
        HepStd::setw(11) << HepStd::setprecision(6) << yz() << ")\n"
     << "     ( " <<
        HepStd::setw(11) << HepStd::setprecision(6) << zx() << "   " <<
        HepStd::setw(11) << HepStd::setprecision(6) << zy() << "   " <<
        HepStd::setw(11) << HepStd::setprecision(6) << zz() << ") ]\n";
	return os;
}

